/************************************************************************\
 *	{W: CHGFONT.C						*
 *	]pت: H STDFONT.15]  STDFONT.24 ^r, 	*
 *		   SPCFSUPP.15]  SPCFSUPP.24 ^C	*
 *		  rC						*
 *	{  : vz (Unicorn)					*
 *	]p: 12-25-1992						*
 ************************************************************************
 *	`Nƶ:							*
 *	    ƫ	e, бN STDFONT.15 , SPCFSUPP.15]  STDFONT.24 , *
 *		SPCFSUPP.24 ^P{ɩbP@ӤlؿUC	*
 *	    Ƭ	OoN SPCFSUPP.15]  SPCFSUPP.24 ^ƥ, HƱN	*
 *		ӭn^Ӯɥ						*
\************************************************************************/

#include <stdio.h>

#define __FONT15__	/* pGzQn 24x24 r, uo@h
			    remark _ӴNiH */

#if defined (__FONT15__)
#define SIZE	30	/* ]w 15x16 rwİϤjp */
#else
#define SIZE	72	/* ]w 24x24 rwİϤjp */
#endif

/**************************************
 *	~BzƵ{
 */
void errexit(int n)
{
    char *errmsg[] = {
#if defined (__FONT15__)
	"STDFONT.15 can not open",
	"SPCFSUPP.15 can not open",
#else
	"STDFONT.24 can not open",
	"SPCFSUPP.24 can not open",
#endif
	"setvbuf failed",
	"fseek failed",
	"fread failed",
	"fwrite failed"
    };

    fprintf(stderr,"\nError: %s ...\n", errmsg[n++]);
    exit(n);
}

/**************************************
 *	D{
 */
void main(void)
{
    FILE *fin, *fout;
    char *code = "H@g⳾ߤkBfեۤu"
		 "{ݤsߨإ|ФKO˦";
    char buf[SIZE], *ptr, hbyte, lbyte;
    long i, k = 318;		/* ܼ k ܦCrO
				    SPCFSUPP.xx ĴXӦr */

    /* LX Title */
    fprintf(stderr,"CHGFONT --- Change ARRAY fonts to DAYI fonts,"
		   " Version 12-25-1992\n");

    /* }ҿXPJɮ */
#if defined (__FONT15__)
    if ((fin = fopen("stdfont.15","rb")) == NULL)
	errexit(0);
    if ((fout = fopen("spcfsupp.15","rb+")) == NULL)
	errexit(1);
#else
    if ((fin = fopen("stdfont.24","rb")) == NULL)
	errexit(0);
    if ((fout = fopen("spcfsupp.24","rb+")) == NULL)
	errexit(1);
#endif

    /* ]w I/O wİ */
    if (setvbuf(fin,NULL,_IOFBF,10240) != 0)
	errexit(2);
    if (setvbuf(fout,NULL,_IOFBF,10240) != 0)
	errexit(2);

    /* }li */
    ptr = code;
    while (*ptr != 0) {

	/* Xrb STDFONT.xx m */
	hbyte = *ptr++;
	lbyte = *ptr++;
	i = (hbyte - 0xA4) * 157 + lbyte;
	i -= (lbyte > 0xA0) ? 0x62 : 0x40;
	if (i > 5400)
	   i -= 408;
	if (fseek(fin,i*SIZE,SEEK_SET))
	    errexit(3);

	/* NrsJ buf  */
	if (fread(buf,1,SIZE,fin) != SIZE)
	    errexit(4);

	/* XQrb SPCFSUOO.xx m */
	if (fseek(fout,(k++)*SIZE,SEEK_SET))
	    errexit(3);

	/* N buf rgJ */
	if (fwrite(buf,1,SIZE,fout) != SIZE)
	    errexit(5);
    }
    fclose(fout);
    fclose(fin);
}
