/************************************************************************\
 *	{W: COD2TAB.C						*
 *	]pت: NtjXΤ媺r DAYI.COD 	*
 *		  DAYI.TAB						*
 *	{  : vz (Unicorn)					*
 *	]p: 12-25-1992						*
 ************************************************************************
 *	`Nƶ: pGb檺lؿUS DAYI.TAB o, Х	*
 *		  N ARRAY.TAB LӻP{ɩbP@	*
 *		  lؿU, ñN ARRAY.TAB W DAYI.TAB C		*
\************************************************************************/

#include <stdio.h>
#include <ctype.h>

/* wqƵc */
union TWOBYTE {
    unsigned i;
    unsigned char byte[2];
};

/**************************************
 *	~BzƵ{
 */
void errexit(int n)
{
    char *errmsg[] = {
	"DAYI.COD can not open",
	"DAYI.TAB can not open",
	"setvbuf failed",
	"Invaild DAYI code",
	"Invalid BIG-5 code",
	"fseek failed"
    };

    fprintf(stderr,"\nError: %s ...\n", errmsg[n++]);
    exit(n);
}

/**************************************
 *	D{
 */
void main(void)
{
    FILE *fin, *fout;
    const static char table[] = {   /* LPCXӪ */
	' ', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J',
	'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U',
	'V', 'W', 'X', 'Y', 'Z', '.', '/', '0', '1', '2', '3',
	'4', '5', '6', '7', '8', '9', ';', ','
    };
    char buf[81], code[4], lbyte, mbyte, hbyte;
    register char ch;
    register unsigned int i, j, hsize;
    union TWOBYTE x;

    /* LX Title */
    fprintf(stderr, "COD2TAB --- Convert DAYI.COD to DAYI.TAB,"
		    " Version 12-25-1992\n");

    /* }ҿXPJɮ */
    if ((fin = fopen("dayi.cod","rt")) == NULL)
	errexit(0);
    if ((fout = fopen("dayi.tab","rb+")) == NULL)
	errexit(1);

    /* ]w I/O wİ */
    if (setvbuf(fin,NULL,_IOFBF,20480) != 0)
	errexit(2);
    if (setvbuf(fout,NULL,_IOFBF,20480) != 0)
	errexit(2);

    /* DX|rϪjp */
    fscanf(fout,"%c%c",&x.byte[0],&x.byte[1]);
    hsize = (x.i + 2) * 2 / 3;
    hsize *= 3;

    while (fgets(buf,80,fin))		/* q DAYI.COD Ū@ */

	if (*buf != ' ' && *buf != '\n') {      /* ˬdO_Ѧ */

	    /* NjLXഫX */
	    code[1] = code[2] = code[3] = 0;
	    for (i = 0; buf[i] != ' ' && buf[i] != '\t'; i++) {
		ch = toupper(buf[i]);
		if (!(isalnum(ch) || ch == ';' ||
			ch == ',' || ch == '.' || ch == '/'))
		    errexit(3);
		for (j = 0; (j < 41) && (table[j] != ch); j++);
		code[i] = j;
	    }
	    lbyte = (code[0] << 2) + (code[1] >> 4);
	    mbyte = (code[1] << 4) + (code[2] >> 2);
	    hbyte = (code[2] << 6) + code[3];

	    /* jLXr */
            while (buf[++i] < 0xA4);

	    /* Ūr */
	    x.byte[1] = buf[i++];
	    x.byte[0] = buf[i];

	    /* ˬdӤrO_@ӦXkr */
	    if (x.byte[0] < 0x40 || x.byte[0] == 0xFF ||
		(x.byte[0] > 0x7E && x.byte[0] < 0xA1))
		errexit(4);
	    else if (x.byte[1] < 0xA4 || x.byte[1] > 0xF9 ||
		(x.i > 0xC67E && x.i < 0xC940))
		errexit(4);
	    else {	/* NrഫʤѧǦCX */
		i = (x.byte[1] - 0xA4) * 157 + x.byte[0];
		i -= (x.byte[0] > 0xA0) ? 0x62 : 0x40;
		if (x.i > 0xC67E)
		    i -= 408;
	    }

	    /* XӤrb DAYI.TAB m */
	    if (fseek(fout,i*3+hsize,SEEK_SET))
		errexit(5);

	    /* NCXgJ */
	    fprintf(fout,"%c%c%c",lbyte,mbyte,hbyte);
	}

    fclose(fout);
    fclose(fin);
}
